netaddr
=======

A network address manipulation library for Python

[![Test coverage](https://codecov.io/gh/netaddr/netaddr/branch/master/graph/badge.svg)](https://codecov.io/gh/netaddr/netaddr)
[![CI](https://github.com/netaddr/netaddr/workflows/CI/badge.svg)](https://github.com/netaddr/netaddr/actions?query=workflow%3ACI+branch%3Amaster)
[![Latest Version](https://img.shields.io/pypi/v/netaddr.svg)](https://pypi.org/project/netaddr/)

Provides support for:

Layer 3 addresses

- IPv4 and IPv6 addresses, subnets, masks, prefixes
- iterating, slicing, sorting, summarizing and classifying IP networks
- dealing with various ranges formats (CIDR, arbitrary ranges and globs, nmap)
- set based operations (unions, intersections etc) over IP addresses and subnets
- parsing a large variety of different formats and notations
- looking up IANA IP block information
- generating DNS reverse lookups
- supernetting and subnetting

Layer 2 addresses

- representation and manipulation MAC addresses and EUI-64 identifiers
- looking up IEEE organisational information (OUI, IAB)
- generating derived IPv6 addresses


Documentation
-------------

Latest documentation https://netaddr.readthedocs.io/en/latest/

Requirements
------------
[![Versions](https://img.shields.io/pypi/pyversions/netaddr.svg)](pypi.python.org/pypi/netaddr)

Share and enjoy!
